; test_timer_pwm with serial controll 
; bei 11.059 MHz Quartz ca 247 kHz max

#include LPx052.H
         .org 0000H
         sjmp start
         .org 000BH          ; TF0 Timer 0 overflow
         cpl P3.4            ; toggle Port pin
         jb  P3.4, pwm_on    ; next on or off ?
pwm_off: mov RL0, R2         ; set off time
         reti
pwm_on:  mov RL0, R1         ; set on time
         reti

start:   mov   P1M0,#01H     ; set ports to quasi bi-direc
         mov   P1M1,#00H     ; and P1.0 to input only
         mov   P3M0,#00H
         mov   P3M1,#10H     ; push pull output for P3.4
         mov   SP,#20H       ; Stack pointer
         clr   TR1           ; stop timer 0 / 1 
         clr   TR0
         mov   TH1,#0DCH     ; 256-6: 9600 baud
         mov   TL1,#0DCH     ; 11.059MHz for SMOD1 =0 
         anl   TMOD,#00H     ; Timer1: 8 bit auto-reload
         orl   TMOD,#20H
         setb  TR1           ; TCON start timer 1
         anl   PCON,#3FH     ; PCON: clear SM0D0 and SM0D0
         mov   SCON,#50H     ; InitRS232 8 bit UART Mode1
         setb  TI
         orl   PCON,#80H     ; SMOD=1 double Baudrate
                             ; Timer 0
         mov   RL0,#0BAH     ; set first RL and RH
         mov   RH0,#0FFH     ; default settings
         mov   R1,#0BAH      ; around 80khz with 11.059Mhz Osz
         mov   R2,#0BAH
         orl   TMOD,#1       ; 16 bit autoreload
         setb  TR0           ; start timer 0 
         
         mov   IE,#82H       ; Interrups EA+ET0 + ES


; RL0:  R1 ON Time, R2 OFF Time;


NEXT     acall RX
         mov   R1,A          ; R1 write ON time
         nop
         mov   A,R1          ; R1  read
         acall TX            ; confirm to user
         acall RX
         mov   R2,A          ; R2 write OFF time
         nop
         mov   A,R2          ; R2  read
         acall TX            ; confirm to user
         acall RX
         mov   RH0,A         ; RH0 write OFF time
         nop
         mov   A,RH0         ; RH0  read
         acall TX            ; confirm to user
         sjmp  NEXT

RX       jnb   RI,RX         ; get RLO from user
         mov   A,SBUF
         clr   RI
         ret

TX       jnb   TI,TX         ; committ value
         clr   TI
         mov   SBUF,A
         ret
        .end
