;Serial port access to modify PWM RL0
;11,059MHz, 19200 Baud (or change SMOD1)
#include LPx052.H
         .org 0000H

INIT     mov   P1M0,#00H       ; set ports to quasi bi-direc
         mov   P1M1,#00H
         mov   P3M0,#00H
         mov   P3M1,#00H
         clr   TR1             ;stop timer 0 / 1 
         clr   TR0
         mov   TH1,#0DCH       ;256-6: 9600 baud
         mov   TL1,#0DCH       ;11.059MHz for SMOD1 =0 
         anl   TMOD,#00H       ;Timer1: 8 bit auto-reload
         orl   TMOD,#20H       ;Timer0: Mode 0
         setb  TR1             ;TCON start timer 
         anl   PCON,#3FH       ;PCON: clear SM0D0 and SM0D0
         mov   SCON,#50H       ;InitRS232 8 bit UART Mode1
         setb  TI
         orl   PCON,#80H       ;SMOD=1 double Baudrate
         mov   TL0,#55H        ;T0 low Byte / Prescaler
         mov   RL0,#55H        ;reload TL0 for linear prescaling
         orl   TCONB,#40H      ;PWM enable P3.5 Timer 0
         mov   A,#55H          ;reload value to accu

         mov   TH0,#55H        ;T0 High byte counter value
         mov   RH0,#0AAH       ;compare value Pulse width
         setb  TR0             ;start timer 0

NEXT     acall RX
         mov   RL0,A           ;RL0 write
         nop
         mov   A,RL0           ;RL0  read
         acall TX              ;confirm to user
         acall RX
         mov   RH0,A           ;RH0 write
         nop
         mov   A,RH0           ;RH0  read
         acall TX              ;confirm to user
         acall RX
         mov   TH0,A           ;TH0 write
         nop
         mov   A,TH0           ;TH0  read
         acall TX              ;confirm to user
         acall RX
         anl   TCONB,#0F8H     ;TCON: clear PSC00 to PSC02
         orl   TCONB,A         ;PSC write
         nop                   ;Timer 0 Mode 0
         mov   A,TCONB         ;PSC  read
         acall TX              ;confirm to user

         sjmp  NEXT

RX       jnb   RI,RX           ; get RLO from user
         mov   A,SBUF
         clr   RI
         ret

TX       jnb   TI,TX           ; committ value
         clr   TI
         mov   SBUF,A
         ret
        .end
